  
"
    __________________________________________________
    @Alejandro F. Reimondo 10/07/99
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

Object subclass: #PrisionModel
  instanceVariableNames: 
    ' handlers '
  classVariableNames: ''
  poolDictionaries: ''  !

PrisionModel subclass: #Actor
  instanceVariableNames: 
    ' lugar '
  classVariableNames: ''
  poolDictionaries: ''  !

Actor subclass: #Banca
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

Banca subclass: #BancaDeCartas
  instanceVariableNames: 
    ' mazo apuestas '
  classVariableNames: ''
  poolDictionaries: '' !

BancaDeCartas subclass: #BancaDelPrisionero
  instanceVariableNames: 
    ' caudales '
  classVariableNames: ''
  poolDictionaries: '' !

Actor subclass: #Jugador
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

Jugador subclass: #JugadorDeCartas
  instanceVariableNames: 
    ' cartas '
  classVariableNames: ''
  poolDictionaries: ''    !

JugadorDeCartas subclass: #JugadorDelPrisionero
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

JugadorDelPrisionero subclass: #Aleatorio
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

JugadorDelPrisionero subclass: #AlgoCooperador
  instanceVariableNames: 
    ' contador '
  classVariableNames: ''
  poolDictionaries: ''  !

JugadorDelPrisionero subclass: #Cooperador
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

JugadorDelPrisionero subclass: #Desertor
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

JugadorDelPrisionero subclass: #DondeLasDanLasToman
  instanceVariableNames: 
    ' ultimaJugada '
  classVariableNames: ''
  poolDictionaries: '' !

DondeLasDanLasToman subclass: #CandidoProbador
  instanceVariableNames: 
    ' contador '
  classVariableNames: ''
  poolDictionaries: ''  !

JugadorDelPrisionero subclass: #Rencoroso
  instanceVariableNames: 
    ' defraudado '
  classVariableNames: ''
  poolDictionaries: '' !

PrisionModel subclass: #Carta
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

Carta subclass: #CartaDelPrisionero
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

CartaDelPrisionero subclass: #Cooperar
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

CartaDelPrisionero subclass: #Desertar
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

PrisionModel subclass: #Casino
  instanceVariableNames: 
    ' creditos lugares '
  classVariableNames: ''
  poolDictionaries: ''  !

PrisionModel subclass: #Lugar
  instanceVariableNames: 
    ' contenedor actores vecinos '
  classVariableNames: ''
  poolDictionaries: '' !

Lugar subclass: #LugarNoHabitable
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

LugarNoHabitable subclass: #CasaDelTesoro
  instanceVariableNames: 
    ' dineroEntregado '
  classVariableNames: ''
  poolDictionaries: ''    !

LugarNoHabitable subclass: #Pared
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

LugarNoHabitable subclass: #Puerta
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

Lugar subclass: #MesaDeJuegos
  instanceVariableNames: 
    ' banca '
  classVariableNames: ''
  poolDictionaries: ''  !

MesaDeJuegos subclass: #MesaDelPrisionero
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

Lugar subclass: #Pasillo
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

Object subclass: #Random
  instanceVariableNames: 
    ' seed '
  classVariableNames: ''
  poolDictionaries: ''    !

Random class instanceVariableNames: ' default '    !


!PrisionModel methods !
  
addDependent: anObject interestIn: anAspect
    "Add a dependent <anObject> that receives an update event when the event named <anAspect> is triggered."

    self
        when: anAspect
        send: #update
        to: anObject!
 
clone
	"Devuelve un clon del receptor."

	^self copy!

esJugador
	"Devuelve true si el receptor es un jugador."

	^false!
   
esLugar
	"Devuelve true si el receptor es un lugar."

	^false!
   
eventTable
    "Private"
    "Answer a Dictionary mapping event names to actions
    for the receiver."

    ^handlers == nil
        ifTrue: [self eventTableCreate]
        ifFalse: [handlers]!
   
eventTableForEdit
    "Private"
    "Answer a Dictionary mapping event names to actions,
    allocate it if necessary."

    handlers == nil
        ifTrue: [handlers := self eventTableCreate].
    ^handlers!
 
nextRandom
	"Devuelve un numero aleatorio entre 0 y 1."

	^self random next!
 
random
	"Devuelve un generador de numeros aleatorios entre 0 y 1."

	^Random default!

randomize: aCollection
	"Devuelve una coleccion con los elementos de aCollection en un orden aleatorio."

	| result remaining index |
	result := OrderedCollection new.
	remaining := aCollection asOrderedCollection copy.
	[remaining notEmpty] whileTrue: [
		index := (self nextRandom * (remaining size - 1)) truncated + 1.
		result add: (remaining remove: (remaining at: index))
	].
	result size = aCollection size ifFalse: [ ^aCollection"^self error: 'Randomizacion con errores.'" ].
	^result!

releaseEventTable
	"Private - break all connections to event handlers."

    handlers := nil!

step
	"Da un paso en la simulacion del receptor.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !



!Actor methods !
 
cohabitantes
	"Devuelve los actores que se encuentran en el mismo lugar que el receptor."

	| result |
	result := Set new.
	self lugar notNil ifTrue: [
		result addAll: self lugar actores
	].
	^result
		remove: self ifAbsent: [];
		yourself!
 
congestionSoportada
	"Devuelve la congestion soportada por el receptor.
	Debe ser un numero mayor de cero que determinara que el receptor no se mueva si hay mucha gente en un pasillo."

	^5 "se mueve si en el pasillo hay hasta este numero de personas"!

deseaMoverseA: unLugar
	" Private - Accion basica de voluntad de moverse a un lugar. "

	"se movera si el lugar no esta muy lleno y muy de vez en cuando"
	^(unLugar actores size <= self congestionSoportada
	or: [ self lugar actores size >= unLugar actores size ])
	and: [ 1 - self movilidad < self nextRandom ]!
   
esBanca
	"Devuelve true si el receptor es una Banca."

	^false!
  
esJugador
	"Devuelve true si el receptor es un jugador."

	^false!
   
is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self implementedBySubclass!
 
is: aState with: puntaje
	"Deve devolver true si el receptor esta en el estado aState teniendo este puntaje.
	Los posibles states son:
		#shy : boca en posicion normal :^|
		#amazed : boca abierta, gritando :^O
		#frown : aflijido :^(
		#smile : sonriendo :^)

		#normal : ojos en posicion normal :^)
		#upset : ojos sorprendidos =^)
		#mad : ojos enojados >^)
	La accion default es devolver siempre true en #shy o #normal
	Las subclases pueden refinar este metodo.
	"

	aState = #normal ifTrue: [ ^true ]. "Solo usaremos iconos para gestos normales;
		aunque las subclases pueden manejar ademas #upset y #mad "

	puntaje > 10000 ifTrue: [ ^aState = #tongue ].
	puntaje > 1000 ifTrue: [ ^aState = #smile ].
	puntaje > 500 ifTrue: [ ^aState = #amazed ].
	puntaje < 50 ifTrue: [ ^aState = #frown ].
	^aState = #shy!
 
lugar
    "Returns the instance var of the receiver
     for external manipulation"
    ^lugar!
  
lugar: aLugar
    "Mueve el receptor a aLugar."

	| anterior |
	lugar == aLugar ifTrue: [^self].
	anterior := lugar. lugar := aLugar.
	anterior notNil ifTrue: [ anterior salio: self ].
	aLugar notNil ifTrue: [ aLugar llego: self ].!
 
movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^0.05 "se mueve el 1% de las veces"!
  
privateLugar: aPuerta
    " NO USAR - Fuerza el lugar del receptor a aPuerta. "

	lugar := aPuerta.!
 
puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea.
	Alli sera aceptado si lo hace ahora... mas tarde las cosas pueden cambiar.
	La accion default es moverse (a veces) si no esta jugando.
	Este metodo puede ser refinado por las subclases. "

	unLugar estaLleno ifTrue: [ ^self ].

	(self lugar esMesa
	and: [self lugar puedeJugar])
	ifTrue: [ ^self ]. "esta comodo jugando"

	(self deseaMoverseA: unLugar)
	ifTrue: [ self lugar: unLugar ]!

quiereJugarEn: aMesa
	"Devuelve true si el receptor desea jugar en aMesa.
	La accion default es responder siempre que si.
	Este metodo puede ser refinado por las subclases."

	^true

	

	!
   
vecinos
	"Devuelve los actores que se encuentran en los lugares vecinos al receptor."

	| result |
	result := Set new.
	self lugar notNil ifTrue: [
		self lugar vecinos do: [:each|
			result addAll: each actores
		]
	].
	^result! !



!Banca methods !
   
abrirJuego
	"Abre el juego para la mesa."

	self implementedBySubclass.!
 
apuestas
	"Devuelve las apuestas que estan sobre el receptor,
	como una colecction de pares #( jugador apuesta ). "

	self implementedBySubclass.!
  
casino
	"Devuelve el casino donde esta el receptor."

	^self mesa casino!

cerrarJuego
	"Cierra el juego para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

congestionSoportada
	"Devuelve la congestion soportada por el receptor.
	Debe ser un numero mayor de cero que determinara que el receptor no se mueva si hay mucha gente en un pasillo."

	^15 "se mueve si en el pasillo hay hasta este numero de personas"!
   
esBanca
	"Devuelve true si el receptor es una Banca."

	^true!
   
evaluarApuestas
	"Evalua las apuestas realizadas en la mesa."

	self implementedBySubclass.!
 
finalizarRonda
	"Cierra una ronda para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases"!
 
iniciarRonda
	"Cierra una ronda para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases"!
   
is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self implementedBySubclass!
 
mesa
	"Devuelve el lugar donde esta el receptor."

	^self lugar!
 
movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^0.05 "se mueve el 5% de las veces"!
  
notificarApuestas
	"Notifica las apuestas realizadas en la mesa."

	self implementedBySubclass.!
 
permitirA: aJugador apostarEn: aMesa
	"Permite que aJugador haga sus apuestas en aMesa."

	aJugador apostarEn: aMesa.!
   
permitirApostar
	" El receptor debe permitir apostar a los jugadores. "

	self mesa jugadores do: [:jugador| self permitirA: jugador apostarEn: self mesa ].!

puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea.
	Las bancas ocupan su lugar en una mesa libre. "

	unLugar esMesa ifTrue: [
		"unLugar estaVacio ifTrue: [ ^false ]."
		unLugar necesitaUnaBanca ifTrue: [ ^self lugar: unLugar ].
		^self
	].

	(self deseaMoverseA: unLugar)
	ifTrue: [ self lugar: unLugar ]! !



!BancaDeCartas class methods !
 
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        addAll: #( repartiendo mezclando );
        yourself! !



!BancaDeCartas methods !
 
abrirJuego
	"Abre el juego para la mesa."

	apuestas := Dictionary new.
	self
		mezclar;
		repartir!
  
aceptarApuesta: aCarta de: aJugador
	" Registra aCarta como una apuesta del jugador aJugador para la ronda actual. "

	apuestas at: aJugador put: aCarta.
	aCarta haSidoJugadaPor: aJugador en: self mesa.!
 
apuestas
	"Devuelve una copia de las apuestas que estan sobre el receptor. "

	apuestas isNil ifTrue: [ ^Array new ].
	^apuestas copy!
  
entregar: count cartasA: aJugador usando: aStream
	" Private - Entrega count cartas a aJugador obteniendolas del stream aStream (el cual debe ser un stream de cartas).
	En caso de acabarse las cartas no entregara mas cartas."

	count timesRepeat: [
		aStream atEnd ifFalse: [
			aJugador tomarCarta: aStream next
		]
	]!

finalizarRonda
	"Cierra una ronda para la mesa."

	apuestas := nil.!
 
initializeMazo
	" Private - Initializes the receiver's mazo"

	mazo := self implementedBySubclass.!
  
mazo
    "Returns the instance var of the receiver
     for external manipulation"

	mazo isNil ifTrue: [ self initializeMazo ].
    ^mazo!

mezclar
	" Private - Mezcla las cartas del mazo.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases. "

    self triggerEvent: #mezclando!
 
notificarApuestas
	"Notifica las apuestas realizadas en la mesa."

	| jugadores apuesta |
	jugadores := apuestas keys asArray.
	jugadores do: [:aJugador|
		apuesta := apuestas at: aJugador.
		(jugadores copyWithout: aJugador)
		do: [:each|
			each
				jugador: aJugador
				aposto: apuesta
		]
	].!
 
repartir
	" Private - Reparte las cartas a los jugadores. "

    self triggerEvent: #repartiendo.
	self mesa jugadores do: [:aJugador| self repartirCartasA: aJugador ]!

repartirCartasA: aJugador
	" Private - Reparte cartas del mazo a aJugador. "

	self implementedBySubclass! !



!BancaDelPrisionero methods !

castigo: aJugador
	"El receptor debera castigar a aJugador."

	self
		multarA: aJugador
		con: (self casino
			puntajeDeCastigo: aJugador
			en: self mesa).!

caudales
    "Returns the instance var of the receiver
     for external manipulation"

	caudales isNil ifTrue: [ caudales := 0 ].
    ^caudales!
  
caudalesMinimos
	" Private - Devuelve los caudales que son considerados minimos para seguir jugando. "

	^self casino caudalesMinimos!
   
cerrarJuego
	"Cierra el juego para la mesa."

	super cerrarJuego.

	"Quita las cartas de la mesa"
	self mesa jugadores do: [:aJugador|
		aJugador cartas: nil.
	].!
 
deseaMoverseA: unLugar
	" Private - Accion basica de voluntad de moverse a un lugar. "

	(unLugar isKindOf: CasaDelTesoro)
	ifTrue: [
		" solo si el receptor no tiene suficiente dinero entrara en la casa del tesoro a buscar mas..."
		self caudalesMinimos * 3 > self caudales ifTrue: [ ^true ].
		"Por ahora haremos que siempre desee entrar para permitir recaudaciones.
		^true "
	].

	(unLugar esMesa and: [unLugar necesitaUnaBanca])
	ifTrue: [ ^true ].

	(unLugar actores detect: [:one| one species = self species ] ifNone: [])
	notNil ifTrue: [ ^false ].

	^super deseaMoverseA: unLugar!
  
evaluarApuestas
	"Evalua las apuestas realizadas en la mesa."

	| jugadores yo tu miApuesta tuApuesta |
	jugadores := self mesa jugadores asArray.
	yo := jugadores first.
	miApuesta := apuestas at: yo.

	tu := jugadores last.
	tuApuesta := apuestas at: tu.

	miApuesta = tuApuesta
	ifTrue: [
		miApuesta esCooperar
		ifTrue: [ self recompensa: yo; recompensa: tu ]
		ifFalse: [ self castigo: yo;castigo: tu ]
	]
	ifFalse: [
		miApuesta esCooperar
		ifTrue: [ self incauto: yo; tentacion: tu ]
		ifFalse: [ self tentacion: yo; incauto: tu ]
	]
	!
 
incauto: aJugador
	"El receptor debera multar a aJugador por incauto."

	self
		multarA: aJugador
		con: (self casino
			puntajeDelIncauto: aJugador
			en: self mesa).!
 
initializeCaudales
	" Private - Initializes the receiver's caudales"

	caudales := self casino caudalesDeInicioPara: self.!
  
initializeMazo
	" Private - Initializes the receiver's mazo. "

	mazo := Array	"Solo usamos dos cartas."
		with: Cooperar new
		with: Desertar new!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self is: aState with: self caudales // 5  "para la banca las cosas son mas graves si no tiene dinero" !
 
mezclar
	" Private - Mezcla las cartas del mazo.
	En el juego del prisionero no se mezclan las cartas,
	 sino que siempre les son entregadas las dos mismas cartas a los jugadores. "

	!
  
movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^self tieneDinero
	ifTrue: [
		(self lugar esMesa ifTrue: [1] ifFalse: [7]) "le gustan mas los pasillos (para permitir llegar a mesas lejanas)"
		* super movilidad
	]
	ifFalse: [ super movilidad * 17 ] "Se mueve mas rapido (corre) si necesita dinero"!
  
multarA: aJugador con: puntos
	" Private - Multa a aJugador con puntos. "

	aJugador multa: puntos.
	self registrarPuntaje: puntos negated para: aJugador.!
 
puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea."

	unLugar esMesa ifTrue: [
		self tieneDinero ifFalse: [ ^false ].
	].
	^super puedeMoverseA: unLugar!
   
quiereJugar
	"Devuelve true si el receptor desea jugar en alguna aMesa."

	^self tieneDinero!

quiereJugarEn: aMesa
	"Devuelve true si el receptor desea jugar en aMesa."

	self quiereJugar ifTrue: [ ^super quiereJugarEn: aMesa ].

	"El receptor no tiene suficiente dinero;
	 por eso saldra de la mesa en la que se encuentra."
	aMesa = self lugar
	ifTrue: [ self lugar: self lugar algunVecino ].

	^false!
 
recompensa: aJugador
	"El receptor debera recompensar a aJugador."

	self
		recompensarA: aJugador
		con: (self casino
			puntajeDeRecompensa: aJugador
			en: self mesa).!
  
recompensarA: aJugador con: puntos
	" Private - Recompensa a aJugador con puntos. "

	aJugador recibir: puntos.
	self registrarPuntaje: puntos para: aJugador.!
 
registrarPuntaje: delta para: aJugador
	" Private - Registra un cambio de puntaje para aJugador. "

	self casino registrarPuntaje: delta para: aJugador.
	caudales := caudales - delta.!

repartirCartasA: aJugador
	" Private - Reparte cartas del mazo a aJugador. "

	aJugador cartas: self mazo copy. "se le reparten todas las cartas."

	"Otra forma de hacerlo...
	self entregar: 2 cartasA: aJugador usando: (ReadStream on: self mazo)
	"!

tentacion: aJugador
	"El receptor debera premiar a aJugador por tentarse con exito."

	self
		recompensarA: aJugador
		con:  (self casino
			puntajeDeTentacion: aJugador
			en: self mesa).!

tieneDinero
    "Devuelve true si el receptor tiene dinero como jugar en alguna aMesa."

    ^self caudales >= self caudalesMinimos! !



!Jugador class methods !
   
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        addAll: #(
			premiado multado
			cambioPuntaje: 
		);
        yourself! !



!Jugador methods !
 
apostarEn: aMesa
	"El jugador ahora puede apostar en aMesa.
	Este metodo debe ser implementado por las subclases."

	^self implementedBySubclass!
   
donar: puntaje a: unJugador
	"El receptor intentara dar una cantidad de puntaje a aJugador."

	^self lugar donacionDe: self a: unJugador de: puntaje!

esJugador
	"Devuelve true si el receptor es un jugador."

	^true!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self is: aState with: self puntaje!
 
multa: puntaje
	"El receptor debe aceptar la multa del puntaje que se le otorga.
	La accion default es no hacer nada.
	Es responsabilidad del receptor acordarse cuanto tiene.
	Este metodo puede ser refinado por las subclases."

    self triggerEvent: #multado.!
 
nombre
	"El receptor debera devolver su nombre.
	La accion default es devolver el nombre de la clase del receptor.
	Este mensaje puede ser refinado por las subclases."

	^self class name!

procrear
	"Si el receptor tiene puntaje suficiente, podra invertir parte de este en tener un hijo.
	El hijo sera de la misma especie (clase) del receptor y poseera un puntaje basico;
	 si el receptor desea darle mas dinero lo podra hacer mediante una donacion (ver #donar:a: ).
	El puntaje minimo para procrear esta dado en Casino>>#puntajeMinimoParaProcrear
	 y el costo esta dado por (puntajeMinimoParaProcrear - puntajeDefault)
	Este metodo devuelve el hijo creado en el mismo lugar donde se encuentra su padre,
	  aunque ambos no se 'conoceran'. Este metodo puede ser refinado por las subclases para mantener contactos familiares.
	"

	^self lugar procreo: self!

puedeProcrear
	"Devuelve true cuando el receptor puede procrear."

	^self lugar puedeProcrear: self!
 
puntaje
	"Devuelve el puntaje del receptor."

	^self lugar puntajeDe: self!
  
puntaje: puntaje
	"El receptor es notificado de su puntaje actual.
	ATENCION: esto NO cambia el puntaje del receptor.
		No es responsabilidad de este mantener su puntaje (aunque podria hacerlo si lo quisiera...).
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."

    self triggerEvent: #cambioPuntaje: with: puntaje!
 
recibir: puntaje
	"El receptor debe recibir el puntaje que se le otorga.
	La accion default es no hacer nada.
	Es responsabilidad del receptor acordarse cuanto tiene.
	Este metodo puede ser refinado por las subclases."

    self triggerEvent: #premiado! !



!JugadorDeCartas class methods !
   
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        add: #tomandoCarta:;
        yourself! !



!JugadorDeCartas methods !
  
cartas
    "Returns the instance var of the receiver
     for external manipulation"

	cartas isNil ifTrue: [ self initializeCartas ].
    ^cartas!

cartas: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    cartas := anObject!
   
initializeCartas
	" Private - Initializes the receiver's cartas"

	cartas := OrderedCollection new.!
 
jugador: aJugador aposto: aCarta
	"El receptor es notificado de la apuesta que ha realizado aJugador en la mesa en la que esta jugando.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

tomarCarta: aCarta
	"El receptor debera tomar aCarta en su poder."

    self triggerEvent: #tomandoCarta: with: aCarta.
	^self cartas add: aCarta

	! !



!JugadorDelPrisionero methods !

apostarEn: aMesa
	"El jugador ahora puede apostar en aMesa."

	| aCarta |
	aMesa banca
		aceptarApuesta: (aCarta := self cartaAJugarEn: aMesa)
		de: self.
    self triggerEvent: #haApostado:en: with: aCarta with: aMesa.!
 
cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self implementedBySubclass!

cooperar
	" Private - Devuelve la carta de cooperar. "

	^self cartas detect: [:one| one esCooperar ]!
   
desertar
	" Private - Devuelve la carta de desertar. "

	^self cartas detect: [:one| one esDesertar ]! !



!Aleatorio methods !
 
cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^(self randomize: self cartas) first! !



!AlgoCooperador methods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self quiereCooperar
	ifTrue: [ self cooperar ]
	ifFalse: [ self desertar ]!
  
contador
    "Returns the instance var of the receiver
     for external manipulation"

	contador isNil ifTrue: [ self initializeContador ].
    ^contador!

contador: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contador := anObject!
   
initializeContador
	" Private - Initializes the receiver's contador"

	contador := 0.!
   
quiereCooperar
	" Private - El receptor devuelve true el 90% de las veces. "

	self contador: self contador + 1 \\ 10.
	^self contador = 0! !



!Cooperador methods !
  
cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self cooperar! !



!Desertor methods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self desertar! !



!DondeLasDanLasToman methods !
 
cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^ultimaJugada isNil
	ifTrue: [ self cooperar ]
	ifFalse: [ ultimaJugada ]!

jugador: aJugador aposto: aCarta
	"El receptor es notificado de la apuesta que ha realizado aJugador en la mesa en la que esta jugando."

	ultimaJugada := aCarta! !



!CandidoProbador methods !
   
cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	| aJugar |
	^(aJugar = self cooperar and: [ self quiereCooperar ])
	ifTrue: [ aJugar ] ifFalse: [ self desertar ]!

contador
    "Returns the instance var of the receiver
     for external manipulation"

	contador isNil ifTrue: [ self initializeContador ].
    ^contador!

contador: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contador := anObject!
   
initializeContador
	" Private - Initializes the receiver's contador"

	contador := 0.!
   
quiereCooperar
	" Private - El receptor devuelve true a veces. "

	self contador: self contador + 1 \\ 7.
	^self contador = 0! !



!Rencoroso methods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self defraudado
	ifTrue: [ self desertar ]
	ifFalse: [ self cooperar ]!
  
defraudado
    "Returns the instance var of the receiver
     for external manipulation"

	defraudado isNil ifTrue: [ self initializeDefraudado ].
    ^defraudado!

defraudado: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    defraudado := anObject!
   
initializeDefraudado
	" Private - Initializes the receiver's defraudado"

	defraudado := false.!
 
multa: puntaje
	"El receptor debe aceptar la multa del puntaje que se le otorga.
	El receptor se siente defraudado si alguna vez es multado."

	super multa: puntaje.
	self defraudado: true.! !



!Carta methods !
   
haSidoJugadaPor: aJugador en: aMesa
	"El receptor ha sido jugada en aMesa por aJugador.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !



!CartaDelPrisionero methods !
 
= otraCarta
	"Las cartas del Prisionero son solo Cooperar y Desertar."

	^self class == otraCarta class!
 
esCooperar
	"Devuelve true is el receptor indica cooperacion."

	^false!
 
esDesertar
	"Devuelve true is el receptor indica desercion."

	^false! !



!Cooperar methods !
  
esCooperar
	"El receptor indica cooperacion."

	^true! !



!Desertar methods !
  
esDesertar
	"El receptor indica desercion."

	^true! !



!Casino methods !
  
add: aLugar
	"Agrega al receptor aLugar."

	^self lugares add: aLugar!
   
caudalesDeInicioPara: aBanca
	"Devuelve los caudales con los que debera arrancar aBanca."

	^self puntajeDefault * 10!
   
caudalesMinimos
	" Private - Devuelve los caudales que son considerados minimos para seguir jugando. "

	^self puntajeDefault // 10!
 
creditos
	" Private - Devuelve la coleccion de creditos.
	Este mensaje no debe ser usado por otros objetos."

	creditos isNil ifTrue: [ self initializeCreditos ].
    ^creditos!
  
donacionDe: aJugador a: otro de: puntaje
	"Efectua la donacion de un determinado puntaje de aJugador a otro.
	Devuelve la cantidad de puntaje donado."

	| donacion |
	"aJugador podra donar tanto como tenga hasta llegar a sus caudales de inicio."
	donacion := puntaje min: (self puntajeDe: aJugador) - self puntajeDefault.
	donacion > 0 ifFalse: [ ^0 ]. "No puede donarse una deuda..."
	self
		registrarPuntaje: donacion negated para: aJugador;
		registrarPuntaje: donacion para: otro;
		yourself.
	^donacion!

initializeCreditos
	" Private - Initializes the receiver's creditos"

	creditos := Dictionary new.!
  
initializeLugares
	" Private - Initializes the receiver's lugares"

	lugares := Set new.!

jugadores
	"Devuelve todos los jugadores que estan dentro del receptor."

	^self creditos keys!
  
lugares
    "Returns the instance var of the receiver
     for external manipulation"

	lugares isNil ifTrue: [ self initializeLugares ].
    ^lugares!

lugares: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lugares := anObject!
 
procreo: aJugador
	" unJugador desea procrear.
	Verifica que este pueda hacerlo.
	Devolvera el hijo si tiene exito; sino devuelve nil."

	| costo |
	(self puedeProcrear: aJugador) ifFalse: [ ^nil ].
	costo := self puntajeMinimoParaProcrear - self puntajeDefault.
	self registrarPuntaje: costo negated para: aJugador.
	^aJugador species new
		lugar: aJugador lugar;
		yourself
	!
  
puedeProcrear: unJugador
	" Devolvera true si unJugador puede procrear ahora. "

	^unJugador lugar estaLleno not
	and: [ (self puntajeDe: unJugador) > self puntajeMinimoParaProcrear ]!

puntajeDe: unJugador
	"Devuelve el puntaje actual del jugador aJugador."

	^self creditos at: unJugador ifAbsent: [ self puntajeDefault ]!
   
puntajeDeCastigo: aJugador en: aMesa
	"El receptor devuelve que puntaje debe cobrarse para castigar a aJugador"

	^10!
   
puntajeDefault
	"Devuelve el puntaje inicial de unJugador."

	^300!
  
puntajeDelIncauto: aJugador en: aMesa
	"El receptor devuelve que puntaje debe cobrarse para castigar al incauto aJugador"

	^100!

puntajeDeRecompensa: aJugador en: aMesa
	"El receptor devuelve que puntaje debe pagarse para recompenzar aJugador"

	^300.!
  
puntajeDeTentacion: aJugador en: aMesa
	"El receptor devuelve que puntaje debe pagarse por tentarse en buen momento a aJugador"

	^500.!
 
puntajeMinimoParaProcrear
	" Devuelve el minimo puntaje para procrear. "

	^self puntajeDefault * 3!
 
puntajes
	"Devuelve todos los jugadores con sus puntajes."

	| result |
	result := SortedCollection sortBlock: [:a :b| a nombre <= b nombre ].
	result addAll: self jugadores.
	^result asArray collect: [:each|
		Array with: each with: (self puntajeDe: each)
		]!
   
puntuaciones
	"Devuelve la tabla de puntuaciones."

	^self puntajes collect: [:tuple|
		Array with: tuple first nombre with: tuple last
	]!

registrarPuntaje: delta para: aJugador
	" Private - Registra un cambio de puntaje para aJugador.
	Devuelve el puntaje que queda para ajugador. "

	| nuevoPuntaje |
	nuevoPuntaje := (self puntajeDe: aJugador) + delta.
	self creditos at: aJugador put: nuevoPuntaje.
	aJugador puntaje: nuevoPuntaje.
	^nuevoPuntaje!

remove: aModel
	"Remueve un lugar de los actuales."

	aModel esJugador ifTrue: [
		creditos removeKey: aModel ifAbsent: [ ^false ].
		^true
	].
	
	aModel esLugar ifTrue: [
		aModel vecinos do: [:each|
			each vecinos remove: aModel ifAbsent: []
		].
		self lugares remove: aModel ifAbsent: [ ^false ].
	].

	^true!
   
seNecesitanBancas
	"Devuelve true si no hay bancas suficientes como para atender todas las mesas."

	| mesasSinBanca bancasPaseando |
	mesasSinBanca := bancasPaseando := 0.
	self lugares do: [:each|
		each esMesa
		ifTrue: [
			each necesitaUnaBanca
			ifTrue: [ mesasSinBanca := mesasSinBanca + 1 ]
		]
		ifFalse: [
			bancasPaseando := bancasPaseando
				+ (each actores select: [:one| one esBanca ]) size
		]
	].
	^mesasSinBanca > bancasPaseando! !



!Lugar class methods !
   
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        addAll: #( lleno vacio llego: salio: );
        yourself!
   
en: unLugar
	"Devuelve una instancia del receptor contenida en unLugar."

	^self new
		contenedor: unLugar;
		yourself! !



!Lugar methods !
  
actores
    "Returns the instance var of the receiver
     for external manipulation"

	actores isNil ifTrue: [ self initializeActores ].
    ^actores!

algunVecino
    "Devuelve algun vecino del receptor.
	Si no tiene vecinos devuelve el receptor."

	self vecinos notEmpty
	ifTrue: [
		^self vecinos at: (self nextRandom * (self vecinos size - 1)) truncated + 1.
	].!
  
casino
	"Devuelve el casino donde esta el receptor."

	| casino |
	casino := self contenedor.
	[ (casino respondsTo: #contenedor)
	  and: [casino contenedor notNil] ]
	whileTrue: [ casino := casino contenedor ].
	^casino!
   
clone
	"Devuelve un clon del receptor, sin conectar a nadie."

	^super clone
		initializeActores;
		initializeVecinos;
		yourself!

contenedor
    "Returns the instance var of the receiver
     for external manipulation"
    ^contenedor!

contenedor: aLugar
    "Sets the instance var of the receiver with aLugar."

    contenedor := aLugar.
	(aLugar respondsTo: #add:) ifTrue: [
		aLugar add: self
	].!
  
convocar: unLugar
	"El receptor debera convocar a sus actores a moverse a unLugar."

	self actores copy do: [:unActor|
		(unLugar puedeContener: unActor)
		ifTrue: [ unActor puedeMoverseA: unLugar ].
	].!
  
convocarVecinos
    "El receptor invita a sus actores a salir a un pasillo."

    self vecinosDesordenados do: [:unLugar|
		unLugar estaLleno ifTrue: [ ^self ].
		self convocar: unLugar.
	].!
   
donacionDe: unJugador a: otro de: puntaje
	"Efectua la donacion de un determinado puntaje de unJugador a otro."

	^self casino donacionDe: unJugador a: otro de: puntaje!

esLugar
	"Devuelve true si el receptor es un lugar."

	^true!

esMesa
	"Devuelve true si el receptor es una mesa."

	^false!

esPasillo
	"Devuelve true si el receptor es un pasillo."

	^false!
   
estaLleno
	"Devuelve true si el receptor esta lleno (no puede permitir el ingreso de otros actores).
	La respuesta default es false (por lo que el receptor tiene cupo inlimitado).
	Este metodo puede ser refinado por subclases."

	^false!
  
estaVacio
	"Devuelve true si el receptor esta vacio."

	^actores size = 0!
   
initializeActores
	" Private - Initializes the receiver's actores"

	actores := OrderedCollection new.!
  
initializeVecinos
	" Private - Initializes the receiver's vecinos"

	vecinos := OrderedCollection new.!
  
lindaCon: aLugar
	"Devuelve true si el receptor linda con aLugar."

	^self vecinos includes: aLugar!
 
llego: unActor
	" Private - unActor llego al receptor. "

	self actores add: unActor.
	self triggerEvent: #llego: with: unActor.
	self estaLleno ifTrue: [
		self triggerEvent: #lleno
	].
	self changed.!
  
necesitaUnaBanca
	"El receptor NO necesita una banca."

	^false!
 
procreo: aJugador
	" unJugador desea procrear.
	Verifica que este pueda hacerlo.
	Devolvera el hijo si tiene exito; sino devuelve nil."

	^self casino procreo: aJugador!
  
puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	La respuesta default es true (por lo que el receptor tiene cupo inlimitado).
	Este metodo puede ser refinado por subclases."

	^true!

puedeProcrear: aJugador
	"Devuelve true cuando aJugador puede procrear."

	^self casino puedeProcrear: self!
 
puedeSerVecinoDe: aLugar
	"Deve devolver true si el receptor puede ser vecino de aLugar.
	La accion default es devolver true; este metodo puede ser refinado por las subclases."

	^true!
   
puntajeDe: unJugador
	"Devuelve el puntaje de unJugador."

	^self casino puntajeDe: unJugador!
   
salio: unActor
	" Private - unActor salio del receptor. "

	self actores remove: unActor ifAbsent: [ self error: 'El ',unActor class name,' no estaba aqui.' ].
	self triggerEvent: #salio: with: unActor.
	self estaVacio ifTrue: [ self triggerEvent: #vacio ].
	self changed.!
 
step
    "Da un paso en la simulacion del receptor.
    Si el receptor tiene actores tratara de inducirlos a salir a un pasillo."

    super step.
    self convocarVecinos.!
  
vecinos
    "Returns the instance var of the receiver
     for external manipulation"

	vecinos isNil ifTrue: [ self initializeVecinos ].
    ^vecinos!

vecinosDesordenados
    "Devuelve los vecinos del receptor en un orden aleatorio."

	^self randomize: self vecinos! !



!LugarNoHabitable methods !
 
puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	La respuesta es false."

	^false!
 
step
    "Da un paso en la simulacion del receptor.
    Si el receptor tiene actores tratara de inducirlos a salir a un pasillo.
    Si no lo desean, los obligara a hacerlo."

    | stream |
    super step.
    self vecinos isEmpty ifTrue: [ ^self ].
    stream := ReadStream on: (self vecinos"Desordenados" select: [:one| one estaLleno not ]) asArray.
	stream atEnd ifTrue: [ ^self ].
    self actores copy do: [:each|
        stream atEnd ifTrue: [ stream reset ].
        each lugar: stream next.
    ].! !



!CasaDelTesoro methods !
  
dineroEntregado
    "Returns the instance var of the receiver
     for external manipulation"

	dineroEntregado isNil ifTrue: [ self initializeDineroEntregado ].
    ^dineroEntregado!

dineroEntregado: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    dineroEntregado := anObject!
 
esNecesarioCrearBancas
	"Devuelve true si el receptor detecta que es necesaria alguna banca mas en el casino."

	^self casino seNecesitanBancas!
 
initializeDineroEntregado
	" Private - Initializes the receiver's dineroEntregado"

	dineroEntregado := 0.!
  
llego: unActor
	" Private - unActor llego al receptor. "

	unActor esBanca ifTrue: [ self preparar: unActor ].
	^super llego: unActor!
  
nuevaBanca: unaBanca
	" Private - unaBanca ha sido creada en receptor. "

	unaBanca lugar: self.
	"Terminal bell."!
 
preparar: aBanca
	" Private - Llena el bolsillo de aBanca con dinero. "

	self dineroEntregado: self dineroEntregado + aBanca caudales.
	aBanca initializeCaudales.
	self dineroEntregado: self dineroEntregado - aBanca caudales.!

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento."

	^unActor esBanca!

salio: unActor
	" Private - unActor salio del receptor. "

	unActor esBanca ifTrue: [ self preparar: unActor ].
	^super salio: unActor!
 
step
    "Da un paso en la simulacion del receptor.
    Si el receptor tiene vecinos con bancas sin dinero;
		las atraera con lo que aumenta su superficie efectiva
		de contacto con el casino."

    super step.
    self vecinos notEmpty ifTrue: [
		self vecinos do: [:aLugar|
			(aLugar actores select: [:each| each esBanca and: [each tieneDinero not]])
			do: [:necesitada| necesitada lugar: self ].
		].
	].! !



!Pared methods !

estaLleno
	"Devuelve true si el receptor esta lleno."

	^true! !



!Puerta methods !

esIndeseable: unActor
    " Private - Devuelve true si el receptor es indeseable para el casino y debera ser expulsado. "

	^unActor esJugador and: [ (self puntajeDe: unActor) <= 0 ]!
  
estaLleno
	"Devuelve true si el receptor esta lleno."

	^false!
  
llego: unActor
	" Private - unActor llego al receptor. "

	unActor esJugador ifFalse: [
		^self error: 'Por aqui solo puede salir un jugador.'
	].

	self casino remove: unActor.
	self triggerEvent: #llego: with: unActor.
	"Quienes llegan a la puerta son olvidados"!
  
nuevoJugador: unActor
	" Private - unActor llego al receptor. "

	self actores add: unActor.
	unActor privateLugar: self.
	self changed.!
  
puedeContener: unActor
    "Devuelve true si el receptor soporta el ingreso de unActor en este momento.
    Solo se acepta jugadores indeseables."

	^unActor esJugador and: [ self esIndeseable: unActor ]!

step
    "Da un paso en la simulacion del receptor.
    Si el receptor tiene vecinos con actores sin dinero; los atraera a salir del casino."

    self vecinos notEmpty ifTrue: [
		self vecinos do: [:aLugar|
			(aLugar actores select: [:each| self esIndeseable: each ])
			do: [:condenado| condenado lugar: self ].
		].
	].
    super step.! !



!MesaDeJuegos class methods !
   
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        addAll: #(
			iniciandoRonda apuestasRealizadas
			apuestasEvaluadas juegoAbierto
			convocandoJugadores finalizandoRonda
		);
        yourself! !



!MesaDeJuegos methods !
   
abrirJuego
	" El receptor debe abrir el juego para una nueva ronda. "

	self banca abrirJuego.
	self triggerEvent: #juegoAbierto.
!

aceptarJugadores
	" El receptor puede convocar nuevos jugadores.
	La accion default es convocar nuevos jugadores de los lugares vecinos.
	Este metodo puede ser refinado por las subclases."

	self triggerEvent: #convocandoJugadores.
	self pasillos do: [:unLugar| unLugar convocar: self ].!
  
apuestas
	"Devuelve las apuestas que estan sobre el receptor,
	como una colecction de pares #( jugador apuesta ). "

	^banca notNil
	ifTrue: [ self banca apuestas ]
	ifFalse: [ Array new ]!
 
banca
    "Returns the instance var of the receiver
     for external manipulation"
    ^banca!
  
banca: aBanca
    "Sets the instance var of the receiver and updates its place."

	aBanca == banca ifTrue: [ ^self ].
	aBanca notNil & banca notNil ifTrue: [ ^self error: 'Ya tenia una banca...' ].

    banca := aBanca.
	aBanca notNil ifTrue: [ aBanca lugar: self ].!
  
bancaClass
	" Private - Devuelve la clase que puede ser banca del receptor."

	^self implementedBySubclass!
  
cantidadDeLugares
	" Private - Devuelve la catidad de lugares donde pueden hubicarse los jugadores.
	Esto limita la cantidad de jugadores que pueden estar jugando.
	Este mensaje debe ser implementado por las subclases "

	^self implementedBySubclass!
 
cerrarJuego
	" El receptor debe cerrar el juego de la ronda actual. "

	self banca cerrarJuego.
	self triggerEvent: #juegoCerrado.!
 
clone
	"Devuelve un clon del receptor, sin su banca."

	^super clone
		banca: nil;
		yourself!
 
convocar: unLugar
	"El receptor debera convocar a sus actores a moverse a unLugar."

	| aBanca |
	super convocar: unLugar.

	self estaVacio
	ifTrue: [
		self necesitaUnaBanca not
		ifTrue: [ self banca puedeMoverseA: unLugar ]
	]
	ifFalse: [
		(unLugar actores select: [:one| one esBanca ])
		do: [:each| each puedeMoverseA: self ]
	].!
  
esMesa
	"Devuelve true si el receptor es una mesa."

	^true!
 
estaLlena
	"Devuelve true si el receptor esta llena."

	^self estaLleno!
 
estaLleno
	"Devuelve true si el receptor esta lleno (no puede permitir el ingreso de otros actores)."

	^self jugadores size >= self cantidadDeLugares!
  
evaluarApuestas
	" El receptor puede evaluar las apuestas realizadas en esta ronda. "

	self banca
		evaluarApuestas;
		notificarApuestas.
	self triggerEvent: #apuestasEvaluadas.
	self changed.!
   
finalizarRonda
	" Private - Se finaliza la nueva ronda.
	La accion default es delegar en la banca.
	Este mensaje puede ser refinado por las subclases."

	self triggerEvent: #finalizandoRonda.
	self banca notNil ifTrue: [
		self banca finalizarRonda
	].!
   
iniciarRonda
	" Private - Se inicia una nueva ronda.
	La accion default es delegar la accion en la banca.
	Este mensaje puede ser refinado por las subclases."

	self triggerEvent: #iniciandoRonda.
	self banca notNil ifTrue: [
		self banca iniciarRonda
	].!

jugadores
    "Devuelve los actores hubicados en el receptor."

	^self actores!
  
jugar
	"Juega una ronda con los jugadores que tenga."

	self iniciarRonda.
	self puedeJugar
	ifTrue: [
		self
			abrirJuego;
			permitirApostar;
			cerrarJuego;
			evaluarApuestas
	].
	self
		aceptarJugadores;
		finalizarRonda;
		yourself.!
 
llego: unActor
	" Private - El receptor debe aceptar el ingreso de unActor.
	El receptor dejara entrar jugadores hasta que este lleno. "

	unActor esBanca ifTrue: [ ^self banca: unActor ].

	self estaLleno ifTrue: [
		self error: 'La mesa no acepta mas jugadores.'
	].
	^super llego: unActor!
   
necesitaUnaBanca
	"Devuelve true si el receptor necesita una banca."

	^banca isNil!
 
pasillos
	"Devuelve los pasillos que lindan con el receptor."

	^self vecinos!
   
permitirAbandono: aCollection
	" Private - Permite el abandono de los jugadores en aCollection que lo deseen. "

	aCollection do: [:aJugador|
		(aJugador quiereJugarEn: self)
		ifFalse: [
			self pasillos detect: [:aPasillo|
				aJugador puedeMoverseA: aPasillo.
				aJugador lugar == self "se movio"
			] ifNone: [
				"no quiere jugar, pero tampoco se quiso retirar...
				 entonces aqui se queda."
			].
		].
	].!
  
permitirApostar
	" El receptor debe permitir apostar a los jugadores. "

	self banca permitirApostar.
	self triggerEvent: #apuestasRealizadas.
	self changed.!
 
puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	Acepta jugadores que quieran jugar el juego."

	unActor esBanca ifTrue: [ ^self necesitaUnaBanca ].
	^unActor quiereJugarEn: self!
   
puedeJugar
	" El receptor debe responder si en este momento puede realizar una ronda.
	La accion default es responder true si hay algun jugador y un representante de la banca que desee jugar.
	Este metodo puede ser reimplementado por las subclases."

	self permitirAbandono: self jugadores copy.
	^self jugadores size = self cantidadDeLugares
	and: [ self necesitaUnaBanca not
	and: [ self banca quiereJugarEn: self ]]!
 
puntajes
	"Devuelve los puntajes de los jugadores que estan jugando en el receptor."

	^self jugadores collect: [:each|
		Array
			with: each
			with: (self puntajeDe: each)
		]!
   
salio: unActor
	" Private - unActor salio del receptor. "

	unActor == self banca ifTrue: [
		self banca: nil.
		^self changed
	].
	^super salio: unActor!
   
step
    "Da un paso en la simulacion del receptor."

    super step.

	" Las bancas saldran del home cada tanto. "
	"
	(self necesitaUnaBanca and: [ self estaLlena ])
	ifTrue: [ self banca: self bancaClass new ].
	"

	self jugar.! !



!MesaDelPrisionero methods !

bancaClass
	" Private - Devuelve la clase que puede ser banca del receptor."

	^BancaDelPrisionero
	!
   
cantidadDeLugares
	" Private - Devuelve la catidad de lugares donde pueden hubicarse los jugadores.
	Esto limita la cantidad de jugadores que pueden estar jugando."

	^2!
  
iniciarRonda
	" Private - Se inicia una nueva ronda.
	Se eliminaran de la mesa los jugadores sin dinero."

	| stream aLugar |
	super iniciarRonda.
	(stream := ReadStream on: self vecinosDesordenados) atEnd
	 ifTrue: [ ^self ]. "no hay donde mandarlos..."

	(self jugadores select: [:one| (self tieneCredito: one) not ])
	do: [:each|
		stream atEnd ifTrue: [ stream reset ].
		aLugar := stream next.
		aLugar estaLleno ifFalse: [ each lugar: aLugar ].
	].!
   
puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	Solo se acepta jugadores con plata y que quieran jugar el juego."

	(self tieneCredito: unActor) ifFalse: [ ^false ].
	^super puedeContener: unActor!

puedeJugar
	" El receptor debe responder si en este momento puede realizar una ronda."

	^super puedeJugar and: [ self estaLleno ]!
  
tieneCredito: aJugador
	" Private - Devuelve true si aJugador tiene credito. "

	^aJugador esJugador and: [ (self puntajeDe: aJugador) >= 0 ]! !



!Pasillo methods !
   
esPasillo
	"Devuelve true si el receptor es un pasillo."

	^true! !



!Random class methods !
   
default
    "Returns the instance var of the receiver
     for external manipulation"

	default isNil ifTrue: [ self initializeDefault ].
    ^default!

default: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    default := anObject!
 
initializeDefault
	" Private - Initializes the receiver's default"

	default := self new.!
   
seed: anInteger
    "Anwer a new Random stream with the initial seed anInteger. Due
    to a limitation of the Park and Miller algorithm, the seed cannot
    be zero."

    ^self new seed: anInteger; yourself! !



!Random methods !
   
initializeSeed
    " Private - Initializes the receiver's seed."

	seed := Time millisecondClockValue bitOr: 1!
  
next
    "Answer a pseudo-Random floating point number between 0 and 1.
    By default we use the Park & Miller minimum standard generator (which
    unfortunately uses LargeInteger arithmetic)."

    ^self nextPM!
 
next: anInteger
    "Answer an Array of anInteger pseudo-random Floats between 0 and 1."

    ^(1 to: anInteger) collect: [ :i | self next ]!

nextLehmer
    "Private - Answer a Random Float between 0 and 1. Uses Lehmer's linear congruential method."

    seed := self peekSeedLehmer.
    ^seed / SmallInteger largestPositive asFloat!
 
nextPM
    "Private - Answer a pseudo-Random floating point number between 0 and 1.
    Uses Park and Miller's 'Minimum Standard' congruential generator
    (see 'Numerical Recipes in C', 2nd Edition; Press, Flannery,
    Teukolsky and Vetterling; Cambridge University Press, 1992)."

    seed := self peekSeedPM.
    ^seed / 16r7FFFFFFF asFloat!
   
peek
    "Answer a pseudo-Random floating point number between 0 and 1 generated
    from the next seed, but do not advance down the stream (i.e. self peek = self peek)."

    ^self peekPM!
   
peekLehmer
    "Private - Answer a pseudo-Random floating point number between 0 and 1."

    ^self peekSeedLehmer / SmallInteger largestPositive asFloat!
   
peekPM
    "Private - Answer a pseudo-Random floating point number between 0 and 1.
    Uses Park and Miller's 'Minimum Standard' congruential generator."

    ^self peekSeedPM / 16r7FFFFFFF asFloat!
 
peekSeedLehmer
    "Private - Answer the next Integer seed calculated using Lehmer's linear congruential
    method. The seed is in the range 0..16r3FFFFFFF."

    ^(self seed * 31415821) + 1 bitAnd: SmallInteger largestPositive!
   
peekSeedPM
    "Private - Answer the next Integer seed calculated using Park and Miller's 'Minimum Standard'
    congruential generator. The seed is in the range 0..16r7FFFFFFF."

    ^self seed * (7 raisedTo: 5) asInteger \\ 16r7FFFFFFF!
  
seed
    "Answer the receiver's seed."

	seed isNil ifTrue: [ self initializeSeed ].
    ^seed!
 
seed: anInteger
    "Set the seed of the Random stream to anInteger (or 1 if zero)."

    seed := anInteger max: 1! !
