  
"
    __________________________________________________
    @Alejandro F. Reimondo 10/07/99
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

Object subclass: #GUIObject
  instanceVariableNames: 
    ' model coordinator '
  classVariableNames: 
    ' ImageCache '
  poolDictionaries: ''  !

GUIObject subclass: #GUIController
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' VirtualKeyConstants '   !

GUIController subclass: #ConnectController
  instanceVariableNames: 
    ' source destination '
  classVariableNames: ''
  poolDictionaries: ''    !

GUIController subclass: #DefaultController
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

GUIController subclass: #MoveController
  instanceVariableNames: 
    ' moved '
  classVariableNames: ''
  poolDictionaries: ''    !

MoveController subclass: #AlignController
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

GUIController subclass: #RemoveController
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

GUIObject subclass: #GUIView
  instanceVariableNames: 
    ' boundingBox '
  classVariableNames: ''
  poolDictionaries: '' !

GUIView subclass: #GUIComposite
  instanceVariableNames: 
    ' parts '
  classVariableNames: ''
  poolDictionaries: ''    !

GUIComposite subclass: #CasinoGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

GUIView subclass: #LugarGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LugarGUI subclass: #FactoryGUI
  instanceVariableNames: 
    ' rate counter classes '
  classVariableNames: ''
  poolDictionaries: ''  !

FactoryGUI subclass: #CasaDelTesoroGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

FactoryGUI subclass: #PuertaGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LugarGUI subclass: #MesaDeJuegosGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

MesaDeJuegosGUI subclass: #MesaDelPrisioneroGUI
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LugarGUI subclass: #PasilloGUI
  instanceVariableNames: 
    ' layout '
  classVariableNames: ''
  poolDictionaries: ''    !

ApplicationCoordinator subclass: #GUICoordinator
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

GUICoordinator subclass: #CasinoCoordinator
  instanceVariableNames: 
    ' casinoGUI controller graphPane fileName lastCreatedItem simulationProcess notifier '
  classVariableNames: ''
  poolDictionaries: ''   !


!GUIObject class methods !
   
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        add: #modelHasChanged;
        yourself!

imageCache
    "Returns the instance var of the receiver
     for external manipulation"

	ImageCache isNil ifTrue: [ self initializeImageCache ].
    ^ImageCache!

imageNamed: aName
	"Devuelve una imagen de nombre aName.
	Genra un error si no ha sido encontrada."

	^self imageNamed: aName ifAbsent: [ self error: 'Imagen no encontrada', aName ]!
  
imageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada."

	| image |
	^self imageCache
	at: aName
	ifAbsent: [
		image := self
			loadImageNamed: aName
			ifAbsent: [ ^aBlock value ].
		self imageCache at: aName put: image
	]!
   
initializeImageCache
	" Private - Initializes the receiver's imageCache"

	ImageCache := Dictionary new.!

loadImageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada."

	| fileName pathName |
	fileName := aName,'.Bmp'.
	pathName := File findFileName: 'images\',fileName.
	pathName isNil ifTrue: [
		pathName := File findFileName: fileName.
	].
	pathName isNil ifTrue: [ ^aBlock value ].
	[ ^DIB fromFile: pathName ] on: Error do: [ ^aBlock value ].!

on: aModel
	"Devuelve una instancia del receptor trabajando sobre aModel."

	^self new
		model: aModel;
		yourself!

oneOf: aCollection
	"Permite al usuario elegir alguno de los objetos en aCollection.
	Si aCollection contiene un solo elelmento, no pregunta y lo devuelve.
	Si aCollection esta vacia o el usuario cancela, devuelve nil."

	aCollection isEmpty ifTrue: [ ^nil ].
	aCollection size = 1 ifTrue: [ ^aCollection asArray first ].
	^(ListChooser
		openOn: aCollection
		prompt: 'Elija una opcion.') selection! !



!GUIObject methods !
 
coordinator
    "Returns the instance var of the receiver
     for external manipulation"
    ^coordinator!
  
coordinator: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    coordinator := anObject!
 
fileOutSurrogate: anObjectFiler
	" Answer surrogate for object filing after performing any dump preprocessing. "

	| surrogate |
	surrogate := super fileOutSurrogate: anObjectFiler.
    ^surrogate copy
		privateCoordinator: nil;
		yourself!
 
imageNamed: aName
	"Devuelve una imagen de nombre aName.
	Genra un error si no ha sido encontrada."

	^self class imageNamed: aName!

imageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada."

	^self class imageNamed: aName ifAbsent: aBlock!
   
initMenu
	"Este metodo esta implementado para soportar que el receptor sea owner de menues."!
  
mark: anObject
	"Marca graficamente el objeto anObject."

	anObject isNil ifTrue: [ ^self ].
	anObject isRectangle ifFalse: [ ^self mark: anObject boundingBox ].
	self coordinator graphPane pen reverse: anObject!
   
model
    "Returns the instance var of the receiver
     for external manipulation"
    ^model!
  
model: aModel
    "Sets the instance var of the receiver with aModel."

    model := aModel.
	self triggerEvent: #modelHasChanged.
	aModel when: aModel changedEventName send: #update to: self.!
  
mouseLocation
	" Private - Devuelve la posicion del cursor."

	^self coordinator mouseLocation!
  
objectUnderCursor
	" Private - Devuelve el objeto bajo el cursor."

	^self coordinator objectUnderCursor!

privateCoordinator: anObject
    " Private - Sets the instance var of the receiver."

    coordinator := anObject!
   
updateView
	"Update the view."

	self coordinator updateView! !



!GUIController methods !
  
button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

canInspectModel
	" Private - Devuleve true si el usuario puede inspeccionar el modelo. "

	^self model notNil and: [ self model respondsTo: #inspect ].!
 
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!
   
displaySelectionIn: aPane
	"El receptor puede mostrar la seleccion actual en aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

doubleClicked: aPane
    "Se ha dobleclickeado sobre aPane.
    La accion default es no hacer nada.
    Este metodo puede ser refinado por las subclases."!
  
inspectModel
	" Private - Permite al usuario inspeccionar el modelo. "

	self model inspect.!

inspectObject
	" Private - Permite al usuario inspeccionar el objeto bajo el cursor o el modelo. "

	| object |
	object := self objectUnderCursor.
	object notNil
	ifTrue: [ object model inspect ]
	ifFalse: [ self inspectModel ]!
 
menu
	" Private - El receptor debe devolver un menu apto para ser usado como menu contextual.
	La accion default es presentar un menu de inspeccion del modelo.
	Este metodo puede ser refinado por las subclases."

	| object menu subMenu |
	self canInspectModel ifFalse: [ ^nil ].
	object := self objectUnderCursor.
	menu := Menu new
        owner: self; title: '&Opciones';
        appendItem: '&inspeccionar...' selector: #inspectObject;
		yourself.
	((object respondsTo: #menu)
	and: [ (subMenu := object menu) notNil ])
	ifTrue: [
		menu
			appendSeparator;
			appendSubMenu: subMenu
	].
	^menu!

mouseMoved: aPane
	"El mouse se ha movido sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !



!ConnectController methods !
   
button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	Detecta el objeto a mover."

	super button1Down: aPane.
	source := self objectUnderCursor.
	(self canConnect: source) ifFalse: [ ^source := nil ].
	self mark: source.!
 
button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane."

	super button1Moved: aPane.
	source notNil ifTrue: [
		self mark: destination.
		destination := self objectUnderCursor.
		(self canConnect: source to: destination)
		ifTrue: [ self mark: destination ]
		ifFalse: [ destination := nil ]
	].!
 
canConnect: anObject
	"Returns true if the receiver can connect anObject."

	^anObject model respondsTo: #vecinos!
   
canConnect: anObject to: another
	"Returns true if the receiver can connect anObject to another."

	^(self canConnect: another)
	and: [ anObject ~= another
	and: [ anObject model puedeSerVecinoDe: another model ]]!
 
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	super clicked: aPane.
	self button1Moved: aPane.
	self mark: source.
	(source notNil and: [ destination notNil ])
	ifTrue: [ self connect: source to: destination ].
	source := destination := nil.!

connect: anObject to: another
	"Connect anObject to another."

	(anObject model lindaCon: another model)
	ifTrue: [
		(MessageBox confirm: anObject model asString ,' y ',another model asString
			,'\Ya han sido conectados...\\Seguro desea desconectarlos ?'withCrs)
		ifFalse: [ ^self ].
		anObject model vecinos remove: another model ifAbsent: [].
		another model vecinos remove: anObject model ifAbsent: [].
	]
	ifFalse: [
		anObject model vecinos add: another model.
		another model vecinos add: anObject model.
	].
	self updateView.!
 
displaySelectionIn: aPane
	"El receptor puede mostrar la seleccion actual en aPane."

	| color aPen lugares dest |
	super displaySelectionIn: aPane.

	aPen := aPane pen.
	color := aPen foreColor.
	lugares := self lugares.
	lugares do: [:each|
		each model vecinos do: [:vecino|
			dest := lugares detect: [:one| one model = vecino].
			aPen
				foreColor: (each species == dest species
					ifTrue: [Color blue]
					ifFalse: [Color darkBlue]);
				place: each center;
				goto: dest center
		].
	].
	aPen foreColor: color.!

lugares
	" Private - Devuelve los lugaresGUI del receptor. "

	^self model parts! !



!DefaultController methods !
  
doubleClicked: aPane
	"Se ha dobleclickeado sobre aPane."

	self objectUnderCursor model inspect.! !



!MoveController methods !

button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	Detecta el objeto a mover."

	super button1Down: aPane.
	moved := self objectUnderCursor.
	moved canBeMoved ifFalse: [ ^moved := nil ].!
 
button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane."

	super button1Moved: aPane.
	moved notNil ifTrue: [
		moved centerAt: self mouseLocation. 
		self updateView.
	].!
 
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	super clicked: aPane.
	self button1Moved: aPane.
	moved := nil.! !



!AlignController methods !
   
align: parts to: object
	"Alinea las partes en parts con respecto a object."

	object isNil | parts isEmpty ifTrue: [ ^nil ].
	self
		alignHorizontal: parts to: object;
		alignVertical: parts to: object;
		yourself!
  
alignHorizontal: parts to: object
	" Private - Alinea horizontalmente las partes en parts con respecto a object."

	| min max x |
	min := object left. max := object right.
	parts do: [:each|
		(each center x between: min and: max)
		ifTrue: [ each centerAt: object center x @ each center y ]
	]!
 
alignVertical: parts to: object
	" Private - Alinea verticalmente las partes en parts con respecto a object."

	| min max x |
	min := object top. max := object bottom.
	parts do: [:each|
		(each center y between: min and: max)
		ifTrue: [ each centerAt: each center x @ object center y ]
	]!
 
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	| parts object |
	super clicked: aPane.
	object := self objectUnderCursor.
	object canBeMoved ifFalse: [ ^self ].
	parts := self model parts select: [:each| each isKindOf: object class ].
	self
		align: parts to: object;
		updateView;
		yourself.! !



!RemoveController methods !
 
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	| object |
	super clicked: aPane.
	object := self objectUnderCursor.
	(object notNil and: [ object ~= model ])
	ifTrue: [
		self mark: object.
		(MessageBox confirm: 'Seguro desea eliminar : ',object asString)
		ifTrue: [ self model remove: object ].
		self updateView.
	].! !



!GUIView class methods !

checkInstances
	" Private - Checkea las instancias del receptor.
	GUIView allSubclasses do: [:each| each checkInstances ]
	"

	self allInstances do: [:each| each check ].!

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        add: #boundsChanged;
        yourself!
  
for: aModel in: aCoordinator
	"Devuelve una instancia del receptor apta para manejar aModel
	o nil si nadie puede manejarlo."

	| aClass |
	aClass := self withAllSubclasses
		detect: [:one| one instancesCanHandle: aModel ]
		ifNone: [ ^nil ].
	^(aClass on: aModel)
		coordinator: aCoordinator;
		yourself!
 
instancesCanHandle: aModel
	" Private - Debe devolver true si las instancias del receptor pueden manejar aModel.
	La accion default es responder true si el nombre de la clase del modelo
     concuerda en parte con el del receptor.
	Este mensaje puede ser refinado por las subclases. "

	^(aModel class name,'GUI') = self name! !



!GUIView methods !

backColor
	"Returns the receiver's floor color."

	^Color darkRed!
   
bottom
    "Returns the bottom coordinate of the receiver."

	^self boundingBox bottom!
  
boundingBox
    "Returns the instance var of the receiver
     for external manipulation"

	boundingBox isNil ifTrue: [ self initializeBoundingBox ].
    ^boundingBox!

boundingBox: aRectangle
    "Sets the instance var of the receiver.
	Returns nil if the boundingBox is not changed."

	boundingBox = aRectangle ifTrue: [ ^nil ].
    self privateBoundingBox: aRectangle.
	self triggerEvent: #boundsChanged.!
   
canBeMoved
	"El receptor puede negarse a moverse graficamente.
	La accion default es ser siempre movible
	Este metodo puede ser refinado por las subclases."

	^true!
  
center
	"Devuelve el centro del area del receptor."

	^self boundingBox center!
  
centerAt: aPoint
	"Mueve el centro del area del receptor a aPoint."

	self boundingBox moveTo: aPoint - (self extent // 2)!
  
check
	" Private - El receptor puede checkear su arquitectura y ''arreglarse'' si asi lo desea."

	self model release.
	self model: self model. "reconnect the model"!
  
clone
	"Devuelve un clon del receptor."

	^self copy
		privateBoundingBox: self boundingBox deepCopy;
		model: self model clone;
		yourself!
  
containsPoint: aPoint
	"Devuelve true si aPoint esta contenido en el receptor."

	^self boundingBox containsPoint: aPoint!
   
defaultBoundingBox
	" Devuleve el boundingBox default para el receptor.
	Este metodo puede ser refinado por las subclases."

	^0@0 extent: self defaultExtent!
  
defaultExtent
	"Devuelve el extent default para el receptor."

	^self imageExtent!
   
displayWith: aPen
	"Display the receiver with aPen.
	The default action is to fill with backcolor if the receiver is not transparent."

	self isTransparent ifFalse: [
		aPen fill: self boundingBox color: self backColor
	].
	self image notNil
	ifTrue: [
		self image
			displayWith: aPen
			from: self image boundingBox
			to: self boundingBox
	].!

extent
    "Returns the extent of the receiver."

	^self boundingBox extent!
 
height
    "Returns the height of the receiver."

	^self boundingBox height!
 
image
    "Returns the receiver's image.
	The default action is to return nil.
	This method can be refined by subclasses."

	^nil!
 
imageExtent
	"Devuelve el extent de la imagen del receptor.
	Si no tiene imagen devuelve 0@0"

	^self image notNil
	ifTrue: [ self image extent ]
	ifFalse: [ 0@0 ]!
  
initializeBoundingBox
	" Private - Initializes the receiver's boundingBox"

	boundingBox := self defaultBoundingBox.!

isTransparent
	"Returns true if the receiver is transparent.
	By default the receiver is opaque."

	^false

	!

left
    "Returns the left coordinate of the receiver."

	^self boundingBox left!

leftBottom
    "Returns the leftBottom coordinate of the receiver."

	^self boundingBox leftBottom!
  
leftTop
    "Returns the leftTop coordinate of the receiver."

	^self boundingBox leftTop!
   
privateBoundingBox: aRectangle
    "Sets the instance var of the receiver."

    boundingBox := aRectangle.!
 
right
    "Returns the right coordinate of the receiver."

	^self boundingBox right!
 
rightBottom
    "Returns the rightBottom coordinate of the receiver."

	^self boundingBox rightBottom!
   
step
	"Da un paso en la simulacion del receptor.
	La accion default es propagar el evento al modelo.
	Este metodo puede ser refinado por las subclases."

	^self model step!
   
top
    "Returns the top coordinate of the receiver."

	^self boundingBox top!
   
update
	"Update the receiver."

	self coordinator updateView: self.!
 
whoContains: aPoint
	"Devuelve el receptor si aPoint esta contenido en el, sino devuelve nil.
	Este mensaje puede ser refinado por las subclases."

	^(self containsPoint: aPoint) ifTrue: [ self ]!

width
    "Returns the width of the receiver."

	^self boundingBox width! !



!GUIComposite methods !
   
addPart: aPart
	"Agrega una parte al receptor."

	self parts add: aPart.!

addParts: aCollection
	"Agrega una coleccion de partes al receptor."

	aCollection do: [:each| self addPart: each ].!

coordinator: anObject
    "Sets the coordinator of the receiver."

	super coordinator: anObject.
	self parts do: [:each| each coordinator: anObject ].!
 
displayWith: aPen
	"Display the receiver with aPen."

	self exposedAreas do: [:area|
		aPen fill: area color: self backColor.
	].
	self parts do: [:each|
		each displayWith: aPen
	].!
 
exposedAreas
	" Private - Returns the areas not covered by the parts. "

	| remaining opaques areas |
	remaining := Array with: self boundingBox.
	opaques := (self parts
		select: [:each| each isTransparent not ])
		collect: [:part| part boundingBox ].
	opaques do: [:opaque|
		areas := Set new.
		remaining do: [:each|
			(opaque intersects: each)
			ifTrue: [ areas addAll: (each nonIntersections: opaque) ]
			ifFalse: [ areas add: each ]
		].
		remaining := areas.
	].
	^remaining!
  
initializeParts
	" Private - Initializes the receiver's parts"

	parts := OrderedCollection new.!

parts
    "Returns the instance var of the receiver
     for external manipulation"

	parts isNil ifTrue: [ self initializeParts ].
    ^parts!

step
	"Da un paso en la simulacion del receptor."

	super step.
	self parts do: [:each| each step ].!
   
whoContains: aPoint
	"Devuelve el receptor si aPoint esta contenido en el, sino devuelve nil.
	Considera que aPoint puede estar sobre una parte del receptor."

	| result |
	(super whoContains: aPoint) isNil ifTrue: [ ^nil ].
	self parts do: [:aPart|
		result := aPart whoContains: aPoint.
		result notNil ifTrue: [ ^result ].
	].
	^self "aPoint esta sobre el fondo."! !



!CasinoGUI methods !
 
addPart: aPart
	"Agrega una parte al receptor."

	super addPart: aPart.
	self model add: aPart model.!
  
canBeMoved
	"El receptor nopuede moverse graficamente."

	^false!

casino
	"El casino es el modelo del receptor."

	^self model!

checkParts
	" Private - El receptor debera checkear sus partes para garantizar que todas representan una vista del modelo. "

	| lugares toRemove |
	lugares := self model lugares copy.
	toRemove := Set new.
	self parts do: [:each|
		lugares
			remove: each model
			ifAbsent: [ "esta GUI es obsoleta"
				toRemove add: each
			]
	].
	self parts removeAll: toRemove.
	"los lugares que quedaron no tienen GUI."
	self addParts: (lugares collect: [:each| GUIView for: each in: self ]).!
   
displayWith: aPen
	"Display the receiver with aPen."

	self boundingBox: aPen boundingBox.
	^super displayWith: aPen!
   
initializeModel
	"Initialize the receiver with a default model."

	self model: Casino new.!
  
model
    "Returns the instance var of the receiver
     for external manipulation"

	model isNil ifTrue: [ self initializeModel ].
    ^model!

model: aModel
	"The model of the receiver will be changed to aModel."

	super model: aModel.
	self checkParts.!
 
newCasaDelTesoro
	"Permite al usuario crear una CasaDelTesoro en el modelo.
	Devuelve una GUI a la CasaDelTesoro creada."

	| casa casaGUI |
	casa := CasaDelTesoro en: self casino.
	casaGUI := GUIView for: casa in: self coordinator.
	casaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: casaGUI.
	^casaGUI!
   
newMesa
	"Permite al usuario crear una nueva mesa en el modelo.
	Devuelve una GUI a la mesa creada."

	| aClass mesa mesaGUI |
	aClass := self class oneOf: MesaDeJuegos allSubclasses.
	aClass isNil ifTrue: [ ^nil ].
	mesa := aClass en: self casino.
	mesaGUI := GUIView for: mesa in: self coordinator.
	mesaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: mesaGUI.
	^mesaGUI!
 
newPasillo
	"Permite al usuario crear un nuevo pasillo en el modelo.
	Devuelve una GUI al pasillo creada."

	| aClass pasillo pasilloGUI |
	aClass := self class oneOf: Pasillo withAllSubclasses.
	aClass isNil ifTrue: [ ^nil ].
	pasillo := aClass en: self casino.
	pasilloGUI := GUIView for: pasillo in: self coordinator.
	pasilloGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: pasilloGUI.
	^pasilloGUI!

newPuerta
	"Permite al usuario crear una puerta de entrada en el modelo.
	Devuelve una GUI a la puerta creada."

	| puerta puertaGUI |
	puerta := Puerta en: self casino.
	puertaGUI := GUIView for: puerta in: self coordinator.
	puertaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: puertaGUI.
	^puertaGUI!

remove: aGUIObject
	"Elimina aGUIObject del receptor."

	self model remove: aGUIObject model.
	self parts remove: aGUIObject.! !



!LugarGUI methods !
 
displayActoresWith: aPen
	" Private - Muestra los actores con aPen.
	La accion default es disponer los actores en orden mientras se pueda."

	| stream place image |
	stream := ReadStream on: self model actores asArray.
	place := self left @ self top.
	[ stream atEnd ] whileFalse: [
		image := self imageFor: stream next.
		place x + image width - 1 > self right
		ifTrue: [ place x: self left; y: place y + image height + 1 ].
		place y + image height > self bottom ifTrue: [
			aPen
				fill: (self leftBottom +(1@-2) rightBottom: self rightBottom+(-1@0))
				color: Color red. " aPen centerText: '+' at: self center + 2. "
			^self
		].
		image displayAt: place with: aPen.
		place x: place x + image width + 1
	].!
   
displayWith: aPen
	"Display the receiver with aPen."

	super displayWith: aPen.
	self displayActoresWith: aPen.!

imageFor: aJugador
	" Private - Devuelve una imagen apropiada para mostrar aJugador. "

	| aName state |
	aJugador isNil ifTrue: [ ^nil ].
	aJugador esBanca ifTrue: [
		^self imageForBanca: aJugador
	].
	aName := String new.
	#(
		( shy amazed frown smile )
		( normal upset mad )
	) do: [:tuple|
		state := tuple
			detect: [:aState| aJugador is: aState ] ifNone: [ tuple first ].
		aName := aName,'-',state.
	].
	^self imageNamed: (aName copyFrom: 2 to: aName size)!
   
imageForBanca: aBanca
	" Returns the receiver's banca image. "

	| state |
	state := #( shy amazed frown smile tongue )
		detect: [:one| aBanca is: one ]
		ifNone: [#shy].
	^self imageNamed: 'Banca-',state! !



!FactoryGUI methods !

basicCreateElement
	" Private - Creates a new element from receiver's classes."

	| aName aClass |
	self classes isEmpty ifTrue: [ ^nil ].
	aName := self classes removeFirst.
	aClass := Smalltalk at: aName asSymbol ifAbsent: [ ^nil ].
	self classes addLast: aName.
	^aClass new!
  
classes
    "Returns the instance var of the receiver
     for external manipulation"

	classes isNil ifTrue: [ self initializeClasses ].
    ^classes!

clearRate
	" Private - Clear the receiver's rate"

	rate := 0.!
  
counter
    "Returns the instance var of the receiver
     for external manipulation"

	counter isNil ifTrue: [ self initializeCounter ].
    ^counter!

counter: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    counter := anObject!
 
createElement
	" Private - Create a new element. "

	^self implementedBySubclass!

decrementRate
	" Private - Reduces the receiver's rate"

	self rate: (self rate - 1 max: 0).!

image
	" Returns the receiver's background image. "

	^self imageNamed: self model class name!
   
incrementRate
	" Private - Increment the receiver's rate"

	self rate: self rate + 1!

initializeClasses
	" Private - Initializes the receiver's classes"

	^self implementedBySubclass!

initializeCounter
	" Private - Initializes the receiver's counter"

	counter := 0.!
  
initializeRate
	" Private - Initializes the receiver's rate"

	rate := 7. "cada rate pasos en la simulacion crea un elemento."!
  
rate
    "Returns the instance var of the receiver
     for external manipulation"

	rate isNil ifTrue: [ self initializeRate ].
    ^rate!

rate: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rate := anObject!
   
reset
	"Force reset of the receiver."

	classes := nil.!
 
step
	"Da un paso en la simulacion del receptor."

	super step.
	self rate = 0 ifTrue: [ ^self ].
	self counter: self counter + 1.
	self counter > self rate
	ifTrue: [
		self
			createElement;
			counter: 0
	].! !



!CasaDelTesoroGUI methods !
 
createElement
	" Private - Creates a new jugador."

	| anElement |
	self model esNecesarioCrearBancas
	ifTrue: [
		anElement := self basicCreateElement.
		anElement notNil ifTrue: [ self model nuevaBanca: anElement ].
	].!
  
initializeClasses
	" Private - Initializes the receiver's classes"

	classes := OrderedCollection with: #BancaDelPrisionero!
 
initializeRate
	" Private - Initializes the receiver's rate"

	rate := 3. "cada rate pasos en la simulacion crea un elemento."!
  
menu
	"Devuelve el menu del receptor."

	^Menu new
        owner: self; title: '&Propiedades...';
        appendItem: 'nue&va banca' selector: #createElement;
		appendSeparator;
        appendItem: '&no crear bancas' selector: #clearRate;
        appendItem: '&si crear bancas' selector: #initializeRate;
		appendSeparator;
        appendItem: '&Reset' selector: #reset;
		yourself! !



!PuertaGUI methods !
 
createElement
	" Private - Creates a new jugador."

	| anElement |
	anElement := self basicCreateElement.
	anElement notNil ifTrue: [ self model nuevoJugador: anElement ].!
   
initializeClasses
	" Private - Initializes the receiver's classes"

	classes := (JugadorDelPrisionero allSubclasses
			collect: [:each| each symbol ])
			asOrderedCollection!
 
menu
	"Devuelve el menu del receptor."

	^Menu new
        owner: self; title: '&Propiedades...';
        appendItem: '&Reset' selector: #reset;
		appendSeparator;
        appendItem: '&nuevo Jugador' selector: #createElement;
		appendSeparator;
        appendItem: '&+ crear jugador cada ',(self rate + 1) asString,' pasos' selector: #incrementRate;
        appendItem: '&- crear jugador cada ',(self rate - 1) asString,' pasos' selector: #decrementRate;
        appendItem: '&0 no crear jugadores' selector: #clearRate;
        appendItem: '&reset de creacin de jugadores' selector: #initializeRate;
		yourself! !



!MesaDeJuegosGUI methods !
 
banca
	" Private - devuelve la banca del modelo del receptor. "

	^self model banca!
 
bancaOffset
	" Private - Devuelve el offset de la banca en la imagen receptor. "

	^38@1!

displayActoresWith: aPen
	" Private - Muestra los actores con aPen. "

	self
		displayBancaWith: aPen;
		displayJugadoresWith: aPen;
		displayApuestasWith: aPen;
		yourself.!
   
displayApuestasWith: aPen
	" Private - Muestra las apuestas con aPen. "

	| apuestas jugadores apuesta |
	apuestas := self model apuestas.
	apuestas isEmpty ifTrue: [ ^self ].
	jugadores := self model jugadores.
	1 to: jugadores size do: [:i|
		apuesta := apuestas at: (jugadores at: i) ifAbsent: [].
		apuesta notNil ifTrue: [
			(self image: i forApuesta: apuesta)
				displayAt: self leftTop + (self offsetForApuesta: i)
				with: aPen
		].
	].!
  
displayBancaWith: aPen
	" Private - Muestra la banca con aPen. "

	self banca isNil ifTrue: [ ^self ].
	(self imageForBanca: self banca)
		displayAt: self leftTop + self bancaOffset
		with: aPen!
   
displayJugadoresWith: aPen
	" Private - Muestra los jugadores con aPen. "

	| jugadores offsets imagen |
	jugadores := self model jugadores asArray.
	offsets := ReadStream on: (self offsetsFor: jugadores).
	jugadores do: [:jugador|
		imagen := self imageFor: jugador.
		imagen notNil
		ifTrue: [
			imagen
				displayAt: self leftTop + offsets next
				with: aPen
		]
	].!
  
image
	" Returns the receiver's background image. "

	^self imageNamed: 'Mesa'!
  
image: index forApuesta: aApuesta
	" Private - Devuelve la imagen index de la apuesta aApuesta. "

	^self imageNamed: aApuesta class name,'-',index asString!

offsetForApuesta: index
	" Private - Devuelve el offset de la apuesta[index] en la imagen receptor. "

	^(Array
		with: 2@2
		with: 72@2
		) at: index!
   
offsetsFor: jugadores
	" Private - Devuelve los offsets para mostrar jugadores."

	^self implementedBySubclass! !



!MesaDelPrisioneroGUI methods !
 
offsetsFor: jugadores
	" Private - Devuelve los offsets para mostrar jugadores."

	^Array
		with: 2@23
		with: 75@23! !



!PasilloGUI methods !
   
canBeMoved
	"El receptor nopuede moverse graficamente;
	pues este se adapta graficamente a los objetos que contiene."

	^true"self model vecinos isEmpty"!
  
defaultExtent
	"Devuelve el extent default para el receptor."

	^self defaultWidth @ self defaultHeight!
 
defaultHeight
	"Devuelve el alto default para el receptor."

	^layout = #horizontal
	ifTrue: [ (self imageNamed: 'banca-shy') height ]
	ifFalse: [ (self imageNamed: 'mesa') height ]!
 
defaultWidth
	"Devuelve el ancho default para el receptor."

	^layout = #horizontal
	ifTrue: [ (self imageNamed: 'mesa') width ]
	ifFalse: [ (self imageNamed: 'banca-shy') width ]!
   
displayWith: aPen
	"Display the receiver with aPen."

	super displayWith: aPen.
	aPen
		place: self leftTop;
		box: self rightBottom;
		yourself.!
   
initializeLayout
	" Private - Initializes the receiver's layout"

	layout := #horizontal.!
   
isTransparent
	"Returns true if the receiver is transparent."

	^false!
  
layout
    "Returns the instance var of the receiver
     for external manipulation"

	layout isNil ifTrue: [ self initializeLayout ].
    ^layout!

layout: aSymbol
    "Sets the instance var of the receiver."

	| extent |
    layout := aSymbol.
	extent := self defaultExtent.
	self boundingBox: (self center - (extent  // 2) extent: extent).!

menu
	"Devuelve el menu del receptor."

	^Menu new
        owner: self; title: '&Propiedades...';
        appendItem: '&Rotar' selector: #rotate;
		yourself.!

rotate
	"Rota el receptor 90 grados"

	layout = #horizontal
	ifTrue: [ self layout: #vertical ]
	ifFalse: [ self layout: #horizontal ].
	self updateView.! !



!GUICoordinator methods !
 
objectFiler
	" Private - Devuelve el object filer. "

	^Smalltalk
		at: #ObjectFiler
		ifAbsent: [
		    SmalltalkLibraryBinder bindTo: 'voflr31w'.
			Smalltalk at: #ObjectFiler
				ifAbsent: [ self error: 'ObjectFiler no encontrado.' ]
		]!
  
print
	"The user selected Print from the File menu."

    self graphPane mainWindow print!
   
printSetup
        "Private - User selected the Print Setup menu item
         from the File menu."
    PrintDialog printerSetup! !



!CasinoCoordinator class methods !

buildView: aView forModel: aModel
    " Private - Create the structure of the main window."

    aView
        "  initialSize: 170 @ 270; "
		owner: aModel; label: aModel title;
		when: #aboutToClose send: #stopSimulation to: aModel;
        yourself.

    self makeCasinoPane: aView for: aModel.!
  
constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        add: #modelHasChanged;
        yourself!

controlFont
    " Private - Returns the default font for pages. "

    ^(Font new
        faceName: 'Arial';
        pointSize: 8;
        fixedWidth: false;
        bold: false;
        yourself ) makeFont; yourself!
   
makeCasinoPane: aView for: aModel
    " Private - Create the casino view for aModel."

	| pane |
	pane := GraphPane new.
	pane
		removeHorizontalScrollbarStyle;
		removeVerticalScrollbarStyle;
        font: self controlFont;
		when: #display send: #displayCasinoIn: to: aModel with: pane;
		when: #mouseMoved: send: #mouseMoved: to: aModel with: pane;
		when: #button1Down send: #button1Down: to: aModel with: pane;
		when: #button1Moved send: #button1Moved: to: aModel with: pane;
		when: #clicked: send: #clicked: to: aModel with: pane;
		when: #doubleClicked send: #doubleClicked: to: aModel with: pane;
		when: #needsMenu send: #needsMenu: to: aModel with: pane;
		when: #needsPopupMenu send: #needsPopupMenu: to: aModel with: pane;
		yourself.
    aView addSubpane: pane.
	aModel
		when: #modelHasChanged send: #update to: pane;
		graphPane: pane;
		yourself.! !



!CasinoCoordinator methods !
   
accept
	"Private - User selected Save."

	self objectFiler
		dump: self casinoGUI
		newFile: self fileName.!
   
addElementMenu
	" Private - Devuelve el menu para el agregado de nuevas partes."

	^Menu new
		owner: self;
		title: '\uAgregar...' replaceEscapeCharacters;
		appendItem: '\uUna copia del ltimo agregado' replaceEscapeCharacters selector: #newClone;
		appendSeparator;
		appendItem: '\uMesa' replaceEscapeCharacters selector: #newMesa;
		appendSeparator;
		appendItem: 'Pa\usillo' replaceEscapeCharacters selector: #newPasillo;
		appendItem: '\uPuerta' replaceEscapeCharacters selector: #newPuerta;
		appendItem: 'casa del \uTesoro' replaceEscapeCharacters selector: #newCasaDelTesoro;
		yourself.
	!
  
agregar: anObject
	" Private - Registra el agregado de anObject. "

	self
		lastCreatedItem: anObject;
		letsTheUserMove: anObject!

button1Down: aPane
	"El mouse se ha presionado sobre aPane."

	self controller button1Down: aPane!
   
button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane."

	self controller button1Moved: aPane!
  
casino
    "Returns the receiver's model."

	^self casinoGUI model!
  
casino: aCasino
    "Set the receiver's model to aCasino."

	| old |
	old := casinoGUI.
	self casinoGUI: (CasinoGUI on: aCasino).
	self controller model: aCasino.!
   
casinoGUI
    "Returns the instance var of the receiver
     for external manipulation"

	casinoGUI isNil ifTrue: [ self initializeCasinoGUI ].
    ^casinoGUI!

casinoGUI: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

	casinoGUI release. "release old casinoGUI"
    casinoGUI := anObject.
	casinoGUI notNil ifTrue: [
		casinoGUI coordinator: self.
		self triggerEvent: #modelHasChanged.
	].!
   
clear
	"Clear the notifier."

	self notifier contents: String new!
   
clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	self controller clicked: aPane!
  
controller
    "Returns the instance var of the receiver
     for external manipulation"

	controller isNil ifTrue: [ self initializeController ].
    ^controller!

controller: aGUIController
    "Sets the instance var of the receiver."

	controller release. "release old controller"
    controller := aGUIController.
	controller notNil ifTrue: [
		aGUIController coordinator: self.
		self updateView.
	].!
   
controllersMenu
	" Private - Devuelve el menu para el control de la interfaz. "

	^Menu new
		owner: self;
		title: '\uControladores...' replaceEscapeCharacters;
		appendItem: '\udefault' replaceEscapeCharacters selector: #initializeController;
		appendSeparator;
		appendItem: '\uMover...' replaceEscapeCharacters selector: #setToMoveController;
		appendItem: '\uAlinear...' replaceEscapeCharacters selector: #setToAlignController;
		appendItem: '\uConectar...' replaceEscapeCharacters selector: #setToConnectController;
		appendSeparator;
		appendItem: '\uEliminar...' replaceEscapeCharacters selector: #setToRemoveController;
		yourself.
	!
   
cr
	"Add a CR onto the notifier."

	self notifier cr!

displayCasinoIn: aPane
	"Muestra el modelo en aPane."

	self casinoGUI displayWith: aPane pen.
	self controller displaySelectionIn: aPane.!
 
doubleClicked: aPane
	"Se ha dobleclickeado sobre aPane."

	self controller doubleClicked: aPane!

fileName
    "Returns the instance var of the receiver
     for external manipulation"

	fileName isNil ifTrue: [ self initializeFileName ].
    ^fileName!

fileName: aString
    "Sets the instance var of the receiver."

    fileName := aString.
	self graphPane mainWindow label: self title.!
 
graphPane
    "Returns the instance var of the receiver
     for external manipulation"
    ^graphPane!
  
graphPane: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    graphPane := anObject!
 
informationMenu
	" Private - Devuelve el menu de informacion y estadisticas. "

	^Menu new
		owner: self;
		title: '\uEstadisticas...' replaceEscapeCharacters;
		appendItem: '\uPoblacin' replaceEscapeCharacters selector: #showSpecies;
		appendSeparator;
		appendItem: '\uPuntajes' replaceEscapeCharacters selector: #showScores;
		yourself.
	!
   
initializeCasinoGUI
	" Private - Initializes the receiver's casinoGUI"

	self casino: Casino new.
	(File exists: self fileName)
	ifTrue: [ self loadFromPathName: self fileName ].
	!
 
initializeController
	" Private - Initializes the receiver's controller"

	self controller: (DefaultController on: self casinoGUI).!
 
initializeFileName
	" Private - Initializes the receiver's fileName"

	fileName := 'Default.CAS'.!
   
initializeNotifier
	" Private - Initializes the receiver's notifier"

	notifier := TextWindow
		windowLabeled: 'Informacin del Casino'
		frame: (0@0 extent: Display extent // (3@2)).!
   
initialState: aCasino
    "Set the initial state of the receiver to aCasino."

	self casino: aCasino.!
   
inspectController
	" Private - Lest the user inspect the receiver's controller."

	^self controller inspect!
 
inspectGUI
	" Private - Lest the user inspect the receiver's GUIView."

	^self casinoGUI inspect!

inspectMenu
	" Private - Devuelve el menu de inspeccin. "

	^Menu new
		owner: self;
		title: '\uInspeccionar...' replaceEscapeCharacters;
		appendItem: '\uModelo' replaceEscapeCharacters selector: #inspectModel;
		appendSeparator;
		appendItem: '\uEsta ventana' replaceEscapeCharacters selector: #inspect;
		appendItem: '\uVistas del modelo' replaceEscapeCharacters selector: #inspectGUI;
		appendItem: '\uControl actual' replaceEscapeCharacters selector: #inspectController;
		yourself.
	!

inspectModel
	" Private - Lest the user inspect the receiver's model."

	^self model inspect!

lastCreatedItem
    "Returns the instance var of the receiver
     for external manipulation"
    ^lastCreatedItem!
  
lastCreatedItem: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lastCreatedItem := anObject!
 
letsTheUserMove: anObject
	"Permite al usuario mover anObject."

	| center box |
	anObject isNil ifTrue: [ ^self ].
	box := anObject boundingBox mapToScreen: self graphPane.
	center := Display pointFromUser: box offset: box extent // 2.
	center := center mapToWindow: self graphPane.
	(self casinoGUI containsPoint: center)
	ifTrue: [ anObject centerAt: box extent // 2 + center ].
	self updateView.!
  
loadFromPathName: file
	" Private - Permite al usuario buscar un modelo desde el disco. "

    | aGUI |
	aGUI := self objectFiler loadFromPathName: file.
	(aGUI isKindOf: CasinoGUI)
	ifFalse: [
		(MessageBox confirm: 'El archivo no contiene un Casino...\Desea continuar ?'withCrs)
		ifFalse: [ ^self ].
	].
	self
		controller: nil;
		casinoGUI: aGUI;
		fileName: file;
		updateView;
		yourself.!
  
menu
	" Private - Devuelve el menu default para el receptor."

	| menu |
	menu := Menu new
		owner: self;
		title: '\uCasino' replaceEscapeCharacters;
		appendSubMenu: self addElementMenu;
		appendSubMenu: self controllersMenu;
		appendSeparator;
		appendSubMenu: self simulationMenu;
		appendSubMenu: self informationMenu;
		appendSeparator;
		appendItem: '\uRedibujar' replaceEscapeCharacters selector: #updateView;
		yourself.
	(self respondsTo: #inspect)
	ifTrue: [ menu appendSubMenu: self inspectMenu ].
	^menu!
  
model
	"Returns the receiver's model."

	^self casinoGUI casino!
 
mouseLocation
	"Devuelve la posicion del cursor."

	^self graphPane mouseLocation!
   
mouseMoved: aPane
	"El mouse se ha movido sobre aPane."

	self controller mouseMoved: aPane!
 
needsMenu: aPane
	"El panel necesita su menu."

	aPane setMenu: self menu.!
  
needsPopupMenu: aPane
	"El panel necesita abrir el menu de popUp."

	aPane setPopupMenu: self controller menu.!
  
newCasaDelTesoro
	" Private - Permite el agregado de una nueva CasaDelTesoro (generador de bancas). "

	self agregar: self casinoGUI newCasaDelTesoro!
   
newClone
	" Private - Permite el agregado de un elemento identico al ultimo agregado. "

	| item clone |
	item := self lastCreatedItem.
	item isNil
	ifTrue: [ MessageBox warning: 'Agregue un elemento antes de hacer esto...' ]
	ifFalse: [
		clone := item clone.
		self casinoGUI addPart: clone.
		self agregar: clone.
	].!

newFile
	"Open another window similar to the receiver."

	self species openOn: Casino new.!
  
newMesa
	" Private - Permite el agregado de una nueva mesa. "

	self agregar: self casinoGUI newMesa!

newPasillo
	" Private - Permite el agregado de un nuevo pasillo. "

	self agregar: self casinoGUI newPasillo!

newPuerta
	" Private - Permite el agregado de una nueva puerta de entrada de clientes. "

	self agregar: self casinoGUI newPuerta!
   
nextPutAll: aString
	"Add aString onto the notifier."

	self notifier nextPutAll: aString!
   
notifier
    "Returns the instance var of the receiver
     for external manipulation"

	(notifier isNil or: [ notifier pane isHandleOk not ]) ifTrue: [ self initializeNotifier ].
    ^notifier!
 
notifier: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    notifier := anObject!
   
objectUnderCursor
	"Devuelve el objeto bajo el cursor."

	^self casinoGUI whoContains: self graphPane mouseLocation!
 
openFile
	" Private - Permite al usuario buscar un modelo desde el disco. "

    | dialog file aGUI |
    dialog := FileDialog new.
    dialog
        title: 'Leer de disco...';
        fileSpec: '*.cas';
        addFilter: '*.cas' description: 'Casino Files (*.CAS)';
        defFilter: '*.cas';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
	^self loadFromPathName: file!
  
saveAs
	"Private - User selected SaveAs..."

    | newFileName |
    newFileName := (FileDialog new saveFile: self fileName) file.
    newFileName isNil ifTrue: [ ^nil ].
	self objectFiler
		dump: self casinoGUI
		newFile: newFileName.
	self fileName: newFileName.!
  
setToAlignController
	"Lets the user Align objects"

	self controller: (AlignController on: self casinoGUI).!

setToConnectController
	"Lets the user Connect objects"

	self controller: (ConnectController on: self casinoGUI).!
  
setToMoveController
	"Lets the user move objects"

	self controller: (MoveController on: self casinoGUI).!
   
setToRemoveController
	"Lets the user Remove objects"

	self controller: (RemoveController on: self casinoGUI).!
 
show: aString
	"Add aString onto the notifier."

	self notifier nextPutAll: aString!
 
showScores
	" Private - Estadistica de Puntajes.
	Muestra los jugadores con su puntaje. "

	| species list |
	self cr;show: 'Estadistica de puntajes en ',self title;
		cr;show: ' a las ',Time now asString,' del ',Date today asString,'.'.
	(self casino puntajes asSortedCollection: [:a :b| a last > b last ])
	do: [:tuple|
		self cr;show: '[',tuple first species asString,']'
			,tuple first nombre asString,' -> $',tuple last asString
	].
	self cr.!
   
showSpecies
	" Private - Estadistica de especies.
	Muestra la cantidad de jugadores ordenados por especie. "

	| species list |
	self cr;show: 'Estadistica de especies en ',self title;
		cr;show: ' a las ',Time now asString,' del ',Date today asString,'.'.
	species := (self casino puntajes collect: [:tuple| tuple first species ]) asBag.
	(species asSet asSortedCollection:
		" Class sortBlock "  "...por orden alfabetico"
		[:a :b| (species occurrencesOf: a) > (species occurrencesOf: b) ] "...por orden demografico"
	)
	do: [:aClass|
		self cr;show: (species occurrencesOf: aClass) asString,' -> ',aClass asString
	].
	self cr.!
  
simulationMenu
	" Private - Devuelve el menu para el control de la simulacion. "

	^Menu new
		owner: self;
		title: '\uSimulacin...' replaceEscapeCharacters;
		appendItem: '\uEmpezar' replaceEscapeCharacters selector: #startSimulation;
		appendItem: '\uDetener' replaceEscapeCharacters selector: #stopSimulation;
		appendSeparator;
		appendItem: '\uPaso a paso' replaceEscapeCharacters selector: #stepSimulation;
		yourself.
	!

simulationProcess
    "Returns the instance var of the receiver
     for external manipulation"
    ^simulationProcess!
  
simulationProcess: aProcess
    "Sets the instance var of the receiver with anObject.
	Stop old simulation if running."

	simulationProcess notNil ifTrue: [
		simulationProcess terminate
	].
    simulationProcess := aProcess!

startSimulation
	" Private - Comienza la simulacion. "

	| aProcess |
	aProcess := [
		[true] whileTrue: [
			self stepSimulation.
			Processor yield.
		].
	] forkAt: 3.
	self simulationProcess:	aProcess.!
 
stepSimulation
	" Private - Realiza un paso de simulacion. "

	casinoGUI notNil ifTrue: [
		casinoGUI step
	].!

stopSimulation
	" Private - Finaliza la simulacion. "

	self simulationProcess: nil.!

title
	"Devuelve el titulo del receptor."

	^'Casino [',self fileName,']'!
   
updateView
	" Private - Refresca la interfaz. "

	self graphPane notNil ifTrue: [ self graphPane update ].!
  
updateView: aGUIView
	" Private - Refresca la region cubierta por aGUIView. "

	aGUIView displayWith: self graphPane pen.! !
